From fc935fb2b75c1e14566ebc65354ddbffac2892a8 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 21:19:45 +0000
Subject: [PATCH 1820/2232] Add test of rust::Slice of opaque Rust type


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index df5c279..6814d00 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -121,6 +121,7 @@ pub mod ffi {
         fn c_take_slice_char(s: &[c_char]);
         fn c_take_slice_shared(s: &[Shared]);
         fn c_take_slice_shared_sort(s: &mut [Shared]);
+        fn c_take_slice_r(s: &[R]);
         fn c_take_rust_string(s: String);
         fn c_take_unique_ptr_string(s: UniquePtr<CxxString>);
         fn c_take_unique_ptr_vector_u8(v: UniquePtr<CxxVector<u8>>);
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 2bb7d71..f0bab82 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -289,6 +289,12 @@ void c_take_slice_shared_sort(rust::Slice<Shared> s) {
   }
 }
 
+void c_take_slice_r(rust::Slice<const R> s) {
+  if (s.size() == 2 && s[0].get() == 2020 && s[1].get() == 2021) {
+    cxx_test_suite_set_correct();
+  }
+}
+
 void c_take_rust_string(rust::String s) {
   if (std::string(s) == "2020") {
     cxx_test_suite_set_correct();
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 50a8005..7dfaa3d 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -124,6 +124,7 @@ void c_take_str(rust::Str s);
 void c_take_slice_char(rust::Slice<const char> s);
 void c_take_slice_shared(rust::Slice<const Shared> s);
 void c_take_slice_shared_sort(rust::Slice<Shared> s);
+void c_take_slice_r(rust::Slice<const R> s);
 void c_take_rust_string(rust::String s);
 void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
 void c_take_unique_ptr_vector_u8(std::unique_ptr<std::vector<uint8_t>> v);
diff --git a/tests/test.rs b/tests/test.rs
index 0620a9c..6178d89 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -132,6 +132,7 @@ fn test_c_take() {
         ffi::Shared { z: 4 },
     ];
     check!(ffi::c_take_slice_shared_sort(shared_sort_slice));
+    check!(ffi::c_take_slice_r(&[R(2020), R(2021)]));
     assert_eq!(shared_sort_slice[0].z, 0);
     assert_eq!(shared_sort_slice[1].z, 2);
     assert_eq!(shared_sort_slice[2].z, 4);

